unit Unit2; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  ComCtrls, Buttons, Menus, uplaylistenmanger,Tools,uplaylistbase,Tools_File,plXine,xine;

type

  { TForm2 }

  TForm2 = class(TForm)
    ListView1: TListView;
    MenuItem1: TMenuItem;
    MenuItem10: TMenuItem;
    MenuItem11: TMenuItem;
    MenuItem12: TMenuItem;
    MenuItem13: TMenuItem;
    MenuItem14: TMenuItem;
    MenuItem15: TMenuItem;
    MenuItem16: TMenuItem;
    MenuItem17: TMenuItem;
    MenuItem18: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    MenuItem8: TMenuItem;
    MenuItem9: TMenuItem;
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    Panel2: TPanel;
    PopupMenu1: TPopupMenu;
    PopupMenu2: TPopupMenu;
    PopupMenu3: TPopupMenu;
    SaveDialog1: TSaveDialog;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ListView1DblClick(Sender: TObject);
    // Playliste Öffnen
    procedure MenuItem11Click(Sender: TObject);
    // Playliste Speichern
    procedure MenuItem12Click(Sender: TObject);
    // Playliste Speichern Unter
    procedure MenuItem13Click(Sender: TObject);
    procedure MenuItem1Click(Sender: TObject);
    procedure MenuItem4Click(Sender: TObject);
    procedure MenuItem5Click(Sender: TObject);
    
    procedure MenuItem9Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton3MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpeedButton4Click(Sender: TObject);
  private
    { private declarations }
  public
    Modi:Boolean;
    Xine:TPLXine;
    playlist:TPlaylistenManger;
    // Ob die Playliste verändert wurde
    PlaylisteMod:Boolean;
    procedure PlayFINISHED(data:Pointer);
    procedure OpenPlayliste(const aFileName:String);
    procedure SavePlayliste(const aFileName:String);
    procedure ClosePlayliste;
    
    { public declarations }
  end; 

var
  Form2: TForm2;

implementation

uses Unit1, Unit4;

{ TForm2 }

procedure TForm2.SpeedButton3Click(Sender: TObject);
begin
end;

// Playliste Öffnen
procedure TForm2.MenuItem11Click(Sender: TObject);
begin
  OpenDialog1.InitialDir:='/home/Michael/Music/';
  if OpenDialog1.Execute then OpenPlayliste(OpenDialog1.FileName);
end;

// Playliste Speichern
procedure TForm2.MenuItem12Click(Sender: TObject);
begin
  if playlist.FileName <> '' then
    SavePlayliste(playlist.FileName)
  else
    MenuItem13Click(Sender);
end;

// Speichern Unter
procedure TForm2.MenuItem13Click(Sender: TObject);
begin
  if SaveDialog1.Execute then begin
    playlist.FileName:=SaveDialog1.FileName;
    MenuItem12Click(Sender);
  end;
end;

procedure TForm2.MenuItem1Click(Sender: TObject);
begin

end;

// Alle Ausgewählten Einträge Löschen
procedure TForm2.MenuItem4Click(Sender: TObject);
var
  i:integer;
  r:word;
begin
  if ListView1.SelCount > 0 then begin
    r:=MessageDlg ('Frage', 'Wirklich alle ausgewählten Einträge löschen ?', mtWarning,
                   [mbYes, mbNo],0);
    if r = mrYes then begin
      PlaylisteMod:=True;
      for i:=ListView1.Items.Count-1 downto 0 do begin
        if ListView1.Items[i].Selected then begin
          if TPlaylistenItem(ListView1.Items[i].Data).FileName = playlist.FileName then
            xine.Stop;
          ListView1.Items.Delete(i);
        end;
      end; // for i
    end;
  end;
end;

// Alle "nicht" Ausgewählten Einträge Löschen
procedure TForm2.MenuItem5Click(Sender: TObject);
var
  i:integer;
  r:word;
begin
  if ListView1.SelCount > 0 then begin
    r:=MessageDlg ('Frage', 'Wirklich alle ausgewählten Einträge löschen ?', mtWarning,
                   [mbYes, mbNo],0);
    if r = mrYes then begin
      PlaylisteMod:=True;
      for i:=ListView1.Items.Count-1 downto 0 do begin
        if not ListView1.Items[i].Selected then begin
          if TPlaylistenItem(ListView1.Items[i].Data).FileName = playlist.FileName then
            xine.Stop;
          ListView1.Items.Delete(i);
        end;
      end; // for i
    end;
  end;
end;

procedure TForm2.MenuItem9Click(Sender: TObject);
var
  r:Word;
begin
  if PlaylisteMod then begin
    r:=MessageDlg('Frage', 'Playliste wurde noch nicht gespeichert, jetzt speichern ?', mtWarning,
                   [mbYes, mbNo],0);

    if r = mrYes then
      MenuItem12Click(Sender)
    else
      PlaylisteMod:=False;
  end;
  
  if not PlaylisteMod then begin
    ListView1.Items.Clear;
    playlist.FileName:='';
    xine.Stop;
  end;
end;

procedure TForm2.SpeedButton1Click(Sender: TObject);
begin
end;

procedure TForm2.SpeedButton2Click(Sender: TObject);
begin

end;

procedure TForm2.FormCreate(Sender: TObject);
begin
  xine:=nil;
  Modi:=False;
end;

procedure TForm2.FormActivate(Sender: TObject);
begin
  if not Assigned(xine) then begin
    playlist:=TPlaylistenManger.Create;
    Xine:=TPLXine.Create(false);
    Xine.OnFINISHED:=@PlayFINISHED;
    Xine.init;

    //OpenPlayliste('/media/hda7/test.pls');
  end;
end;

procedure TForm2.FormShow(Sender: TObject);
begin
end;

procedure TForm2.ListView1DblClick(Sender: TObject);
begin
  Form1.BitBtn2Click(sender); // Stopp
  Form1.BitBtn1Click(sender); // Abspielen

end;

procedure TForm2.SpeedButton3MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  t:Integer;
begin
  t:=TSpeedButton(sender).tag;
  TPopupMenu(FindComponent('PopupMenu'+IntTostr(t))).PopUp(mouse.CursorPos.x,mouse.CursorPos.y);
end;

procedure TForm2.SpeedButton4Click(Sender: TObject);
begin
  Form4.ShowModal;
  if Form4.Tag = 1 then begin
    if Form4.RadioGroup1.ItemIndex > -1 then begin
      SpeedButton4.Caption:='Modus:' + Form4.RadioGroup1.Items[Form4.RadioGroup1.ItemIndex];
      writelN('OK');
    end;
  end;
end;

procedure TForm2.PlayFINISHED(data: Pointer);
var
  z,m:Integer;
begin
  xine.OpenF:=False;
  if Assigned(ListView1.Selected) then
    m:=ListView1.Selected.Index
  else
    m:=0;
    
  if Form4.RadioGroup1.ItemIndex > 0 then begin
    z:=playlist.AutoLoadTitel(m,ListView1.Items.Count-1,Form4.RadioGroup1.ItemIndex,Form4.CheckBox1.Checked);
  
    if z > -1 then begin
      ListView1.Selected:=ListView1.Items[z];
      Form1.BitBtn2Click(self);

      Form1.BitBtn1Click(self);
    end;
  end
  else begin
    Form1.BitBtn2Click(self)
  end;
end; // TForm2.PlayFINISHED(data: Pointer)

procedure TForm2.OpenPlayliste(const aFileName: String);
var
  tmp:TStringList;
  i:Integer;
  s:String;
  PlayListItem:TPlaylistenItem;
begin
  ClosePlayliste;
  tmp:=TStringList.Create;
  playlist.LoadFromFile(tmp,aFileName);
  playlist.FileName:=aFileName;
//  writeln(tmp.text);
  
  for i:=0 to tmp.Count-1 do begin
    PlayListItem:=TPlaylistenItem(tmp.Objects[i]);

    with ListView1.Items.Add do begin
      Caption:=GetToken(ExtractFileExt(PlayListItem.FileName),'.',2);
      Xine.NotPlay:=True;
      Xine.FileOpen(PlayListItem.FileName);
      Xine.NotPlay:=False;
      Xine.SetInfo;
      SubItems.Add(tmp[i]);
      SubItems.Add(Xine.GetLen);
      SubItems.Add( FormatFileSize(GetFileSize1(PlayListItem.FileName)));
      Data:=Pointer(tmp.Objects[i]);

    end;
  end; // for i

  Form1.BitBtn3.Enabled:=True;
  Form1.BitBtn4.Enabled:=True;
  Form1.BitBtn5.Enabled:=True;
  Form1.Repaint;
  
  if Form4.CheckBox2.Checked then begin
    if ListView1.Items.Count >= 0 then begin
      ListView1.Selected:=ListView1.Items[0];
      Form1.BitBtn2Click(self);
      Form1.BitBtn1Click(self);
    end;
  end;
end; // TForm2.OpenPlayliste

procedure TForm2.SavePlayliste(const aFileName: String);
var
  i:integer;
  PlayListItem:TPlaylistenItem;
  tmp:TStrings;
begin
  tmp:=TStringList.Create;
  for i:=0 to ListView1.Items.Count-1 do begin
    PlayListItem:=TPlaylistenItem(ListView1.Items[i].Data);
    tmp.AddObject(PlayListItem.FileName,PlayListItem);
  end; // for i
  playlist.SaveToFile(tmp,aFileName);
  PlaylisteMod:=False;
end; // TForm2.SavePlayliste

procedure TForm2.ClosePlayliste;
begin
  if not PlaylisteMod then
    ListView1.Items.Clear
  else begin
    writeln('!! Playliste wurde verändert !!');
  end;
end; // TForm2.ClosePlayliste

initialization
  {$I Unit2.lrs}

end.

