unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  Buttons, StdCtrls, ComCtrls,uplaylistbase,xine;

type

  { TForm1 }

  TForm1 = class(TForm)
    Bevel1: TBevel;
    Bevel2: TBevel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    Panel1: TPanel;
    Timer1: TTimer;
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TrackBar1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TrackBar2Change(Sender: TObject);
  private
    { private declarations }
  public
    UserChangePos:Boolean;
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation

uses Unit2,Unit4;

{ TForm1 }

procedure TForm1.FormShow(Sender: TObject);
begin
  Form2.Show;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  if not UserChangePos then begin
    Form2.Xine.SetInfo;
    TrackBar1.Position:=Form2.Xine.Position;
    Label1.Caption:='Zeit: ' + Form2.Xine.GetCurrTime;
  end;
//  else
  //  UserChangePos:=False;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
end;

procedure TForm1.TrackBar1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Form2.Xine.Pause;
  Timer1.Enabled:=False;
end;

procedure TForm1.TrackBar1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Form2.Xine.Position:=TrackBar1.Position;
  Timer1.Enabled:=True;
end;

procedure TForm1.TrackBar2Change(Sender: TObject);
begin
  Form2.Xine.Volume:=TrackBar2.Position;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var
  s,c:String;
begin
  c:=BitBtn1.Caption;
  if (Form2.ListView1.Selected <> NIL) and (BitBtn1.Tag = 0) then begin
    s:=TPlaylistenItem(Form2.ListView1.Selected.Data).FileName;
    if FileExists(s) then begin
      Form2.Xine.FileOpen(s);
      Form2.Xine.play;
      BitBtn1.Tag:=1;
      BitBtn1.Caption:='&Pause';
      BitBtn2.Enabled:=True;
      BitBtn2.Repaint;
      Timer1.Enabled:=True;
    end
    else
      ShowMessage(Format('Datei "%s" gibt es nicht !',[s]));
  end
  else begin
    if ( BitBtn1.Tag = 1) then begin
      form2.Xine.Pause;
      BitBtn1.Caption:='&Play';
      BitBtn1.Tag:=2;
      Timer1.Enabled:=False;
    end
    else begin
      if ( BitBtn1.Tag = 2) then begin
        BitBtn1.Caption:='&Pause';
        form2.Xine.Pause;
        BitBtn1.Tag:=1;
        Timer1.Enabled:=True;
      end;
    end;
  end;
  TrackBar1.Max:=Form2.Xine.PlayLen;
  TrackBar2.Position:=Form2.Xine.Volume;
  
//  Form2.Xine.FileOpen(ListView1.);
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin

  Form2.Xine.Stop;
  BitBtn1.Caption:='&Play';
  BitBtn1.Tag:=0;
  BitBtn2.Enabled:=False;
end;

procedure TForm1.BitBtn5Click(Sender: TObject);
var
  t,z:Integer;
begin
  t:=TBitBtn(Sender).Tag;
  
  z:=Form2.playlist.AutoLoadTitel(Form2.ListView1.Selected.Index,Form2.ListView1.Items.Count-1,t,True);
  Form2.ListView1.Selected:=Form2.ListView1.Items[z];
  BitBtn2Click(sender); BitBtn1Click(sender);
end;

procedure TForm1.BitBtn6Click(Sender: TObject);
begin
  Form4.Show;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
//  xine_usec_sleep(1000);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  UserChangePos:=False;
end;

procedure TForm1.FormDeactivate(Sender: TObject);
begin
  //xine_usec_sleep(1000);
end;

procedure TForm1.FormPaint(Sender: TObject);
begin

end;

initialization
  {$I Unit1.lrs}

end.

